--- /etc/init.d/dnsmasq.orig	2007-08-24 08:36:50.000000000 +0200
+++ /etc/init.d/dnsmasq	2007-08-24 09:10:51.000000000 +0200
@@ -112,6 +112,21 @@
 	return 0
 }
 
+status()
+{
+	# Return
+	#   0 if daemon is running
+	#   1 if daemon is dead and pid file exists
+	#   3 if daemon is not running
+	#   4 if daemon status is unknown
+	start-stop-daemon --start --quiet --pidfile /var/run/$NAME.pid --exec $DAEMON --test > /dev/null
+	case "$?" in
+		0) [ -e "/var/run/$NAME.pid" ] && return 1 ; return 3 ;;
+		1) return 0 ;;
+		*) return 4 ;;
+	esac
+}
+
 case "$1" in
   start)
 	echo -n "Starting $DESC: $NAME"
@@ -171,8 +186,18 @@
 			;;
 	esac
 	;;
+  status)
+	echo -n "Checking $DESC: $NAME"
+	status
+	case "$?" in
+		0) echo " (running)" ; exit 0 ;;
+		1) echo " (dead, pid file exists)" ; exit 1 ;;
+		3) echo " (not running)" ; exit 3 ;;
+		*) echo " (unknown)" ; exit 4 ;;
+	esac
+	;;
   *)
-	echo "Usage: /etc/init.d/$NAME {start|stop|restart|force-reload}" >&2
+	echo "Usage: /etc/init.d/$NAME {start|stop|restart|force-reload|status}" >&2
 	exit 3
 	;;
 esac
